Bug 490588 - Review Request: minicomputer - Software Synthesizer
Review Request: minicomputer - Software Synthesizer
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Pavel Alexeev
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-03-17 02:15 EDT by Orcan Ogetbil
Modified: 2009-05-12 00:07 EDT (History)
3 users (show)

See Also:
Fixed In Version: 1.3-3.fc11
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-05-11 23:58:08 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
pahan: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Orcan Ogetbil 2009-03-17 02:15:17 EDT
Spec URL: http://oget.fedorapeople.org/review/minicomputer.spec
SRPM URL: http://oget.fedorapeople.org/review/minicomputer-1.3-1.fc10.src.rpm
Description:
Minicomputer is a standalone Linux softwaresynthesizer for creating
experimental electronic sounds as its often used in but not limited to
Industrial music, IDM, EBM, Glitch, sound design and minimal electronic. It is
monophonic but can produce up to 8 different sounds at the same time. It uses
Jack as realtime audio infrastructure and can be controlled via Midi.


rpmlint is silent
Comment 1 Pavel Alexeev 2009-04-19 12:23:58 EDT
I'll [try] (it will be my first review) review it.
Comment 2 Orcan Ogetbil 2009-04-19 18:23:51 EDT
This one is not java, but I'll be glad if you could review it :)
Comment 3 Pavel Alexeev 2009-04-20 01:11:10 EDT
This one is very simple to start only :) Java package will be next ;)

+ MUST: rpmlint must be run on every package. The output should be posted in the review.

rpmlint silent

+ MUST: The package must be named according to the Package Naming Guidelines .
+ MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2].
+ MUST: The package must meet the Packaging Guidelines .
+ MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
+ MUST: The License field in the package spec file must match the actual license. [3]
+ MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
+ MUST: The spec file must be written in American English. [5]
+ MUST: The spec file for the package MUST be legible. [6]
+ MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
- MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]

It is not compiled on PPC and PPC64 architectures: http://koji.fedoraproject.org/koji/taskinfo?taskID=1308092

Please, see logs.
If you suppose it only for few architectures you must add ExclusiveArch tag and comment why you make this decision (and link to bugs, if it is not compiled on any arch).

- MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
+ MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines; inclusion of those as BuildRequires is optional. Apply common sense.
+ MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
No locales
+ MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
+ MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [11]
+ MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [12]
+ MUST: A Fedora package must not list a file more than once in the spec file's %files listings. [13]
+ MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [14]
+ MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [15]
+ MUST: Each package must consistently use macros. [16]
+ MUST: The package must contain code, or permissable content. [17]
+ MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
+ MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
+ MUST: Header files must be in a -devel package. [19]
+ MUST: Static libraries must be in a -static package. [20]
+ MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability). [21]
+ MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]
+ MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [22]
+ MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]
+ MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [23]
+ MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [24]
+ MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [25]
+ MUST: All filenames in rpm packages must be valid UTF-8. [26]

So, package seems very nice for me. Please, do it compatible to build on each supported platforms and I approve them.
Comment 4 Orcan Ogetbil 2009-04-20 02:47:35 EDT
I should have been more careful about compiler flags. Here you go:

Spec URL: http://oget.fedorapeople.org/review/minicomputer.spec
SRPM URL: http://oget.fedorapeople.org/review/minicomputer-1.3-2.fc10.src.rpm

Changelog: 1.3-2
- Disable SSE on unsupported architectures

F-11 build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=1308732
Comment 5 Pavel Alexeev 2009-04-22 08:54:09 EDT
Orcan, why package use self compiller flags?

https://fedoraproject.org/wiki/Packaging:Guidelines#Compiler_flags

Quoting the guidelines:

| Adding to and overriding or filtering parts of these
| flags is permitted if there's a good reason to do so;
| the rationale for doing so should be reviewed and
| documented in the specfile especially in the override
| and filter cases.
Comment 6 Orcan Ogetbil 2009-04-22 11:07:37 EDT
In this case, the flags that I'm overriding for ppc/ppc64 are SSE related. Enabling SSE instruction set may provide some performance boost in those archs that support it. Unfortunately, ppc and ppc64 don't support it so we need to remove those flags when compiling minicomputer in these archs.

Here is more info: http://en.wikipedia.org/wiki/Streaming_SIMD_Extensions
Comment 7 Pavel Alexeev 2009-04-22 11:17:06 EDT
No, no, I now speak about using all flags hard defined in SConstruct. You are put standard Fedora %optflags into begin of its (via sed in spec file), but followed flags its override!!!

I think it is bad idea at all. If you expect from SSE big advantage, you may add it to standard set, defined widely for current platform, but comment in spec for that needed why you do that.
Comment 8 Orcan Ogetbil 2009-04-22 11:28:21 EDT
(In reply to comment #7)
> No, no, I now speak about using all flags hard defined in SConstruct. You are
> put standard Fedora %optflags into begin of its (via sed in spec file), but
> followed flags its override!!!
> 

I am not familiar with all of those flags, but as far as I know, none of 
   '-fwhole-program',
   '-ftree-vectorize',
   '-ffast-math', 
   '-funit-at-a-time',
   '-fpeel-loops',
   '-ftracer',
   '-funswitch-loops',
   '-fprefetch-loop-arrays'
is overriding the Fedora flags. The author picked these probably because these are application specific.

> I think it is bad idea at all. If you expect from SSE big advantage, you may
> add it to standard set, defined widely for current platform, but comment in
> spec for that needed why you do that.  

Again, afaik the code should support SSE if you want to use those flags. 

I think that my comment is clear about this. It says that SSE is only enabled in those supported archs for obvious reasons. What do you want me to add to it?
Comment 9 Pavel Alexeev 2009-04-22 11:46:19 EDT
Guidelines says what *any* what "a adding to and overriding or filtering parts of these flags is permitted if there's a good reason to do so"...

So, not only sse flags here, I speak about all others. I also not familiar with it. General question - is it needed at all?? Can be compiled application whithout those?
And comment about SSE instructions is fully clear for me.
Comment 10 Orcan Ogetbil 2009-04-22 13:01:55 EDT
OK, I got your point now. I know very many packages for which their builders add some extra flags on top of %optflags and I never saw anyone documenting this (unless they are overriding the %optflags).

It is an interesting point and I brought this into the attention of Fedora Packaging ML:
   https://www.redhat.com/archives/fedora-packaging/2009-April/msg00073.html

Thanks for bringing this up. I will act according to the responses we will get.
Comment 11 Orcan Ogetbil 2009-04-25 12:46:35 EDT
Alright, I updated the flags one more time:

Spec URL: http://oget.fedorapeople.org/review/minicomputer.spec
SRPM URL: http://oget.fedorapeople.org/review/minicomputer-1.3-3.fc10.src.rpm

Changelog: 1.3-3
- Cleanup the compiler flags

Rawhide build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=1320465
Comment 12 Pavel Alexeev 2009-04-25 13:29:35 EDT
Ok it seems fine for me now, APPROVED
Comment 13 Orcan Ogetbil 2009-04-25 13:57:24 EDT
Thank you Pavel!

New Package CVS Request
=======================
Package Name: minicomputer
Short Description: Software Synthesizer
Owners: oget
Branches: F-9 F-10 F-11
InitialCC:
Comment 14 Orcan Ogetbil 2009-04-25 15:31:04 EDT
I think you need to assign yourself to the bug and set the bug to ASSIGNED.
Comment 15 Pavel Alexeev 2009-04-27 00:50:39 EDT
Oget, sorry. I have done it.
Comment 16 Kevin Fenzi 2009-04-27 01:18:59 EDT
cvs done.
Comment 17 Fedora Update System 2009-04-27 13:21:15 EDT
minicomputer-1.3-3.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/minicomputer-1.3-3.fc11
Comment 18 Fedora Update System 2009-04-27 13:22:32 EDT
minicomputer-1.3-3.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/minicomputer-1.3-3.fc10
Comment 19 Fedora Update System 2009-04-27 13:23:36 EDT
minicomputer-1.3-3.fc9 has been submitted as an update for Fedora 9.
http://admin.fedoraproject.org/updates/minicomputer-1.3-3.fc9
Comment 20 Fedora Update System 2009-04-27 17:28:21 EDT
minicomputer-1.3-3.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update minicomputer'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2009-3973
Comment 21 Fedora Update System 2009-04-27 17:32:16 EDT
minicomputer-1.3-3.fc9 has been pushed to the Fedora 9 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing-newkey update minicomputer'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F9/FEDORA-2009-3998
Comment 22 Fedora Update System 2009-05-09 00:09:59 EDT
minicomputer-1.3-3.fc11 has been pushed to the Fedora 11 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update minicomputer'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F11/FEDORA-2009-4479
Comment 23 Fedora Update System 2009-05-11 23:58:03 EDT
minicomputer-1.3-3.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 24 Fedora Update System 2009-05-12 00:03:30 EDT
minicomputer-1.3-3.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 25 Fedora Update System 2009-05-12 00:07:35 EDT
minicomputer-1.3-3.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.